/// <reference types="collect.js" />
import { performSafeRequestREST, performSafeRequestGraphql } from '../utils';
import { KeyValueUnknown, ResolvingRESTOptions } from '../typings';
import EventEmitter from '../EventEmitter';
import { DocumentNode } from 'graphql';
export default abstract class Model extends EventEmitter {
    id: string;
    uuid: string;
    loading: boolean;
    createMutation?: string | CallableFunction | DocumentNode;
    updateMutation?: string | CallableFunction | DocumentNode;
    deleteMutation?: string | CallableFunction | DocumentNode;
    protected submittableProps: any[];
    protected __typename: string | undefined;
    protected performSafeRequestGraphql: typeof performSafeRequestGraphql;
    protected performSafeRequestREST: typeof performSafeRequestREST;
    private _exists;
    constructor(props?: {});
    generateUuid(): void;
    get doRequest(): typeof performSafeRequestGraphql | typeof performSafeRequestREST;
    get className(): string;
    get displayClassName(): string;
    get defaultMethod(): string;
    exists(): boolean;
    protected defaults(): KeyValueUnknown;
    protected hydrate(item: any): any;
    protected getMethod(_opts: ResolvingRESTOptions): any;
    toCollection(skipEmpty?: boolean): import("collect.js").Collection<this>;
    toArray(skipEmpty?: boolean): this[];
    getClassName(): string;
    protected getInputFields(): Promise<string[]>;
    getUpdateVariables(): Promise<unknown>;
    toSubmittable(props?: any[]): unknown;
    toSubmittableFormData(props?: any[]): FormData;
    save(): Promise<any>;
    create(params?: unknown, mutation?: string | DocumentNode): Promise<any>;
    update(params?: unknown, mutation?: string | DocumentNode): Promise<any>;
    delete(mutation?: string | DocumentNode, params?: unknown): Promise<any>;
    mutate(mutationOrUrl: any, params: any, method?: string): Promise<unknown>;
    clone(): this;
    markExists(): this;
    markNotExists(): this;
    protected beforeMutate(): Promise<this>;
    protected afterMutate(): this;
    protected resolveRequest(request: string | DocumentNode, defaultRequest: string | CallableFunction | DocumentNode): string | DocumentNode;
    protected resolveParams(params: unknown): Promise<unknown>;
}
//# sourceMappingURL=Model.d.ts.map